;spazer statue by spedimus
;plasma gfx by mccad00
;used mage by biosp4rk
.definelabel Equipment,0x3001530
.definelabel BeamBombActivation,0x300153D
.definelabel Division,0x808AC34
.definelabel Modulo,0x808AD10
.definelabel freespace,0x8762000
.definelabel chargebeamID,0x3001694
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;itemtoggle

; enable item toggle
.org 0x8071C1A
    b       0x8071C36
; allow bombs to be toggled
.org 0x8071BAC
    beq     0x8071C36
    mov     r6,0x80
    ldr     r5,=BeamBombActivation
    b       0x8071C36
    .pool
; allow suits to be toggled
.org 0x8071BE6
    b       0x8071C36
; always draw on/off
.org 0x8071D5A
    b       0x8071D7A

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; beam GFX

;;;;;;;;;;wave GP's
.org 0x8329C6C ;wave horizontal GP
	.word 	0x08329734
	.word	0x00000003
	.word	0x0832973C
	.word	0x00000002
	.word	0x00000000
	.word	0x00000000
.org 0x8329CAC ;wave diagonal GP
	.word 	0x083297BA
	.word	0x00000003
	.word 	0x083297C2
	.word   0x00000002
	.word	0x00000000
	.word	0x00000000
.org 0x8329CEC ;wave Vertical GP
	.word 	0x08329840
	.word	0x00000003
	.word 	0x08329848
	.word   0x00000002
	.word	0x00000000
	.word	0x00000000
;;;;;;;;;;Wave Frames
.org	0x0832973C ; horizontal
	.word	0x40FC0001
	.word	0x20A001FB
.org 	0x083297C2 ; diagonal
	.word 	0x00F90001
	.word	0x20C241F9
.org 	0x08329848 ; vertical
	.word	0x80FB0001
	.word	0x20C601FC



;;;;;;;;;;Charged Wave GP's

.org 0x8329DEC ;Charged wave horizontal GP
	.word 	0x08329A94
	.word	0x00000003
	.word 	0x08329A9C
	.word   0x00000002
	.word	0x00000000
	.word	0x00000000
.org 0x8329E2C ;Charged wave diagonal GP
	.word 	0x08329B02
	.word	0x00000003
	.word 	0x08329B10
	.word   0x00000002
	.word	0x00000000
	.word	0x00000000
.org 0x8329E6C ;Charged wave vertical GP
	.word 	0x08329BD0
	.word	0x00000003
	.word 	0x08329BD8
	.word   0x00000002
	.word	0x00000000
	.word	0x00000000
;;;;;;;;;; charged wave frames
.org 	0x08329A9C
	.word 	0x40f80001
	.word  	0x208381F9


.org 	0x08329B10
	.word	0x00f90002
	.word	0x20C841F9
	.word	0x00040004
	.dh		0x20E7
.org 	0x08329BD8
	.word 	0x80F90001
	.word	0x208C81F8


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; beam hitboxes
;;;;;;;;;;Normal
.org	0x8051108
	.word	0x0000FFEC
	.word	0x0000FFEC
.org	0x080510F8
	.byte	0x14
.org 	0x08051100
	.byte	0x14

.org	0x08051134
	.word	0x0000FFEC
.org	0x08051128
	.byte	0x14

.org 	0x805118C
	.word	0x0000FFEC
.org	0x08051140
	.byte	0x14

;;;;;;;;;;Charged
.org 0x8051800
	.byte	0x18
.org	0x8051808
	.byte	0x18
.org 	0x8051810
	.word	0x0000FFE8
	.word	0x0000FFE8

.org 	0x8051828
	.byte	0x18
.org	0x8051830
	.byte	0x18
.org	0x8051838
	.word	0x0000FFE8
	.word	0x0000FFE8

.org	0x8051848
	.byte	0x18
.org 	0x8051850
	.byte	0x18
.org	0x8051894
	.word	0x0000FFE8
	.word	0x0000FFE8



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Projectile movement



;///////////////////////////////////////////////////////////////////////
;gfx offset plasma 329ED4
;pal offset for plasma 327168
;pal offset for status is 3fd1b0
.org 0x8327168
	.import		"gfx\newplasma.palette"
.org 0x8329ED4
	.import		"gfx\plasmagfx.raw"
.org 0x8409D70
	.import 	"gfx\status.lz"
.org 0x84427DA
	.import 	"gfx\widemessage.raw"
.org 0x84453A4
	.import 	"gfx\spazerdescription.raw"

.org 0x875ec40
	.word 0x82b70e4
	.word 0x82b70e4
.org 0x82b50a4
	.import 	"gfx\widestatue.palette"
;	.import 	"gfx\widestatue2.palette"

;///////////////////////////////////////////////////////////////////////
; make all beams long
.org	0x08050C4C
	nop; short
.org	0x08050E56
	nop; Ice
.org	0x08051180
	nop; Wave
.org	0x08051344
	nop; Plasma
.org	0x08051528
	nop; Charged Short
.org	0x0805174E
	nop; Charged Ice
.org	0x08051888
	nop; Charged Wave
.org	0x08051A6A
	nop; Charged Plasma
;
;///////////////////////////////////////////////////////////////////////
;BEAM DAMAGES
.org	0x0804FFEA
	 mov     r3,2h          ; short
.org	0x0804FFFC
	 mov     r3,3h          ; Spazer
.org	0x0805001A
	 mov     r3,4h          ; Spazer Ice
.org	0x0805002C
	 mov     r3,3h          ; Ice
.org	0x08050052
	 mov     r3,5h          ; Spazer Ice wave
.org	0x08050064
	 mov     r3,4h          ; Spazer Wave
.org	0x0805007E
	 mov     r3,4h          ; Ice Wave
.org	0x08050090
	 mov     r3,3h          ; Wave
.org	0x080500BE
	 mov     r3,6h          ; Spazer Ice Wave Plasma
.org	0x080500D8
	 mov     r3,5h          ; Spazer wave Plasma
.org	0x080500FA
	 mov     r3,5h          ; Ice Spazer/Wave Plasma
.org	0x0805010C
	 mov     r3,4h          ; Ice Plasma
.org	0x08050126
	 mov     r3,4h          ; Spazer/Wave Plasma
.org	0x08050138
	 mov     r3,3h          ; Plasma
.org	0x0805015C
	 mov     r3,8h          ; Charged Short
.org	0x08050174
	 mov     r3,0Ch         ; Charged Spazer
.org	0x08050192
	 mov     r3,10h         ; Charged Spazer Ice
.org	0x080501A4
	 mov     r3,0Ch         ; Charged Ice
.org	0x080501CA
	 mov     r3,14h         ; Charged Spazer Ice Wave
.org	0x080501DC
	 mov     r3,10h         ; Charged Spazer Wave
.org	0x080501F6
	 mov     r3,10h         ; Charged Ice Wave
.org	0x08050208
	 mov     r3,0Ch         ; Charged Wave
.org	0x0805023C
	 mov     r3,18h         ; Charged Spazer Ice Wave Plasma
.org	0x08050256
	 mov     r3,14h         ; Charged Spazer Wave PLasma
.org	0x08050278
	 mov     r3,14h         ; Charged Spazer/Wave Ice Plasma
.org	0x0805028A
	 mov     r3,10h         ; Charged Ice Plasma
.org	0x080502A4
	 mov     r3,10h         ; Charged Spazer/Wave Plasma
.org	0x080502B6
	 mov     r3,0Ch         ; Charged Plasma

;///////////////////////////////////////////////////////////////////////
;;;;;spawn hijack
.org 0x0804EE26
	ldr		r0,=spawnhijack
	mov		r15,r0
.pool


;spazer effect
.org 0804F17Ch
	push	r0
	ldr		r0,=spazer
	mov		r15,r0
.pool

;;;;;refresh projectile type
.org 0x804F674
	mov		r15,r1
.org 0x804f6b8
	.word RefreshBeamtypes

;set separate charge beam gfx
.org 0x804f734
	.word setplasmagfx1
.org 0x804f6f6
	mov		r15,r1


.org 0x804f740
	.word setplasmagfx2
.org 0x804f704
	mov		r15,r1

.org 0x804f748
	.word setplasmagfx3
.org 0x804f710
	mov		r15,r1


.org 0x804f750
	.word setplasmagfx4
.org 0x804f71c
	mov		r15,r1

.org 0x804f8f0
	.word setchargegfx1
.org 0x804f8a0
	mov		r15,r1

.org 0x804f8fc
	.word setchargegfx2
.org 0x804f8ae
	mov		r15,r1

.org 0x804f904
	.word setchargegfx3
.org 0x804f8ba
	mov		r15,r1

.org 0x804f90c
	.word setchargegfx4
.org 0x804f8c6
	mov		r15,r1


;;;;;; Change palette based on beam
.org 0x804f8d8
	mov		r15,r1
.org 0x804f914
	.word shortbeampalettehijack


;;;;;;;short beam split into charge and normal
.org 0x8050bae
	b	0x8050c44
.org 0x08050C44
	ldr		r0,=shortbeamhijack
	mov		r15,r0
.pool


;;;;;;;widen spazer
.org 0x8050D34
	ldr		r0,=widenspazer
	mov		r15,r0
.pool
.org 0x8050ca6 
	b		0x8050d34

;;;;;; Ice beam widens beam
.org 0x08050E3C
	ldr		r0,=widenspazer
	mov		r15,r0
.pool


;;;;;wave hijack
.org 0x8051082
	mov		r15,r0
.org 0x805109C
	.word	wavebeamhijack

;;;;;wave widens beam
.org 0x08051166 
	ldr		r0,=widenspazer
	mov		r15,r0
.pool

;;;;;;wave plasma hijack
.org 0x805119e
	mov		r15,r0
.org 0x80511cc
	.word wavebeamhijack

;;;;;;Plasmabeamhijack
.org 0x805132a 
	ldr		r0,=widenspazer
	mov		r15,r0
.pool
;;;;;;FLARE
.org 0x805144C
	mov		r15,r0
.org 0x8051464
	.word flare

;;;;;;charged short beam
.org 0x08051522
	ldr		r0,=shortbeamhijack ;split beam into charge and normal
	mov		r15,r0
.pool
.org 0x805148a      ;fix despawning glitch for charged shorts
	b		0x8051522

;;;;;;charged spazer
.org 0x0805161C
	ldr		r0,=widenspazer
	mov		r15,r0
.pool
.org 0x0805158E
	b		0x805161c

;;;;;;Ice beam widens beam
.org 0x08051734
	ldr		r0,=widenspazer
	mov		r15,r0
.pool


;;;;;chargedwave hijack gives wave motion
.org 0x805177E
	mov		r15,r0
.org 0x805179C
	.word	wavebeamhijack


;;;;;chargedwave widens beam
.org 0x0805186E
	ldr		r0,=widenspazer
	mov		r15,r0
.pool

;;;;;;charged wave plasma hijack gives wave motion
.org 0x080518A6
	mov		r15,r0
.org 0x80518d4
	.word wavebeamhijack

;;;;;;Charged plasma beam jumps to valid address
.org 0x805192a
	b		0x8051936
.org 0x8051934
	b		0x8051936

;;;;;; fix plasma trail
.org 0x08051936 
	ldr		r0,=fixplasmatrail
	mov		r15,r0
.pool


;;;;;;Charged Plasmabeamhijack widens beam
.org 0x8051a50 
	ldr		r0,=widenspazer
	mov		r15,r0
.pool
	

;clearprojectile1
.org 0x0804EE36
	str	r2,[r3]
.org 0x8050ba2
	str r0,[r4]
.org 0x8050166
	str r0,[r2]
.org 0x804f940
	str r2,[r0]







;///////////////////////////////////////////////////////////////////////

.org 08760FE0h
RefreshBeamTypes:
	ldr		r1,=0x3001530
	ldrb	r0,[r1,0x12]
	cmp		r0,0x2
	beq		@@returnzerosuit
	b		@@notzerosuit
@@returnzerosuit:
	ldr		r0,=0x804f67a
	mov		r15,r0
@@notzerosuit:
	ldrb	r0,[r1,0xd]
	mov		r1,0x8
	and		r1,r0
	cmp		r1,0x8
	beq		@@plasma
	mov		r1,0x8
	and		r1,r0
	cmp		r1,0x8
	beq		@@wave
	mov		r1,0x8
	and		r1,r0
	cmp		r1,0x8
	beq		@@ice
	mov		r1,0x8
	and		r1,r0
	cmp		r1,0x8
	beq		@@long
	b		@@short

@@short:
	mov		r3,0x0
	mov		r4,0x40
	b		@@setptype
@@long:
	mov		r3,0x1
	mov		r4,0x40
	b		@@setptype
@@ice:
	mov		r3,0x2
	mov		r4,0x40
	b		@@setptype
@@wave:
	mov		r3,0x3
	mov		r4,0xA0
	b		@@setptype
@@plasma:
	mov		r3,0x4
	mov		r4,0x50
	b		@@setptype

@@setptype:
	ldr		r2,=0x3000a2c
@@loop:
	ldrb	r1,[r2,0xf]
	cmp		r1,0x5
	bcc		@@setnotcharged
	cmp		r1,0xB
	bcc		@@setcharged
	b		@@continue
@@setnotcharged:
	strb	r3,[r2,0xf]
	strb	r4,[r2,0x12]
	b		@@continue
@@setcharged:
	add		r1,r3,0x6
	strb	r1,[r2,0xf]
	mov		r1,0x80
	strb	r1,[r2,0x12]
	b		@@continue
@@continue:
	add		r2,0x1c
	ldr		r1,=0x3000bec
	cmp		r2,r1
	bcc		@@loop

@@return:
	ldr		r1,=0x3001530
	ldr		r3,=0x804f6e8
	mov		r15,r3
	

	





findchargetwin:
	ldr		r3,=0x3000a2c
	mov		r2,0x0
@@loop:
	mov		r1,0x1c
	mul		r1,r2
	add		r1,r1,r3
	ldrb	r1,[r1,0x1]
	cmp		r0,r1
	beq		@@checkifsame
@@wasthesame:
	add		r2,r2,0x1
	cmp		r2,0x10
	bcs		@@notwin
	b		@@loop
@@checkifsame:
	mov		r1,0x1c
	mul		r1,r2
	add		r1,r1,r3
	cmp		r1,r4
	beq		@@wasthesame
	mov		r0,r1
	b		@@return
@@notwin:
	mov		r0,0x0
	b		@@return
@@return:
	bx		r14



fixplasmatrail:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x6
	and		r1,r0
	cmp		r1,0x6
	beq		@@hasicewave
	mov		r1,0x2
	and		r1,r0
	cmp		r1,0x2
	beq		@@hasice
	mov		r1,0x18
	b		@@return
@@hasicewave:
	mov		r1,0x19
	b		@@return
@@hasice:
	mov		r1,0x1b
@@return:
	mov		r0,r4
	mov		r2,0x7
	ldr		r3,=0x804fc38
	bl		wrapperR3
	ldr		r0,=0x8051a50
	mov		r15,r0
.pool




seticeplasmagfx:
	push	r14
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x4
	and		r1,r0
	cmp		r1,0x4
	bne		@@nowave
	ldrb	r0,[r4,0xf]
	cmp		r0,0x6
	bcc		@@notchargedwave
	bl		setchargedwaveplasmaoam
	b		@@return
@@notchargedwave:
	bl		setnotchargedwaveplasmaoam
	b		@@return
@@nowave:
	ldrb	r0,[r4,0xf]
	cmp		r0,0x6
	bcc		@@notcharged
	bl		setchargediceplasmaoam
	b		@@return
@@notcharged:
	bl		setnotchargediceplasmaoam
@@return:
	pop		r14
	bx		r14

setnotchargediceplasmaoam:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x2
	and		r1,r0
	cmp		r1,0x2
	beq		@@hasice
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontal
	cmp		r0,0x1
	beq		@@diagonal
	cmp		r0,0x2
	beq		@@diagonal
	cmp		r0,0x3
	beq		@@vertical
	cmp		r0,0x4
	beq		@@vertical
@@horizontal:
	ldr		r0,=OAM_plasmahor
	str		r0,[r4,0x4]
	b		@@return
@@diagonal:
	ldr		r0,=OAM_plasmadiag
	str		r0,[r4,0x4]
	b		@@return
@@vertical:
	ldr		r0,=OAM_plasmavert
	str		r0,[r4,0x4]
	b		@@return
@@hasice:
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontalice
	cmp		r0,0x1
	beq		@@diagonalice
	cmp		r0,0x2
	beq		@@diagonalice
	cmp		r0,0x3
	beq		@@verticalice
	cmp		r0,0x4
	beq		@@verticalice
@@horizontalice:
	ldr		r0,=0x832ad20
	str		r0,[r4,0x4]
	b		@@return
@@diagonalice:
	ldr		r0,=0x832ad38
	str		r0,[r4,0x4]
	b		@@return
@@verticalice:
	ldr		r0,=0x832ad50
	str		r0,[r4,0x4]
	b		@@return
@@return:
	bx		r14

setchargediceplasmaoam:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x2
	and		r1,r0
	cmp		r1,0x2
	beq		@@hasice
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontal
	cmp		r0,0x1
	beq		@@diagonal
	cmp		r0,0x2
	beq		@@diagonal
	cmp		r0,0x3
	beq		@@vertical
	cmp		r0,0x4
	beq		@@vertical
@@horizontal:
	ldr		r0,=OAM_chargedplasmahor
	str		r0,[r4,0x4]
	b		@@return
@@diagonal:
	ldr		r0,=OAM_chargedplasmadiag
	str		r0,[r4,0x4]
	b		@@return
@@vertical:
	ldr		r0,=OAM_chargedplasmavert
	str		r0,[r4,0x4]
	b		@@return
@@hasice:
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontalice
	cmp		r0,0x1
	beq		@@diagonalice
	cmp		r0,0x2
	beq		@@diagonalice
	cmp		r0,0x3
	beq		@@verticalice
	cmp		r0,0x4
	beq		@@verticalice
@@horizontalice:
	ldr		r0,=0x832adb0
	str		r0,[r4,0x4]
	b		@@return
@@diagonalice:
	ldr		r0,=0x832adc8
	str		r0,[r4,0x4]
	b		@@return
@@verticalice:
	ldr		r0,=0x832ade0
	str		r0,[r4,0x4]
	b		@@return
@@return:
	bx		r14

setnotchargedwaveplasmaoam:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x2
	and		r1,r0
	cmp		r1,0x2
	beq		@@hasice
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontal
	cmp		r0,0x1
	beq		@@diagonal
	cmp		r0,0x2
	beq		@@diagonal
	cmp		r0,0x3
	beq		@@vertical
	cmp		r0,0x4
	beq		@@vertical
@@horizontal:
	ldr		r0,=OAM_wphor
	str		r0,[r4,0x4]
	b		@@return
@@diagonal:
	ldr		r0,=OAM_wpdiag
	str		r0,[r4,0x4]
	b		@@return
@@vertical:
	ldr		r0,=OAM_wpvert
	str		r0,[r4,0x4]
	b		@@return
@@hasice:
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontalice
	cmp		r0,0x1
	beq		@@diagonalice
	cmp		r0,0x2
	beq		@@diagonalice
	cmp		r0,0x3
	beq		@@verticalice
	cmp		r0,0x4
	beq		@@verticalice
@@horizontalice:
	ldr		r0,=OAM_icehor
	str		r0,[r4,0x4]
	b		@@return
@@diagonalice:
	ldr		r0,=OAM_icediag
	str		r0,[r4,0x4]
	b		@@return
@@verticalice:
	ldr		r0,=OAM_icevert
	str		r0,[r4,0x4]
	b		@@return
@@return:
	bx		r14

setchargedwaveplasmaoam:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x2
	and		r1,r0
	cmp		r1,0x2
	beq		@@hasice
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontal
	cmp		r0,0x1
	beq		@@diagonal
	cmp		r0,0x2
	beq		@@diagonal
	cmp		r0,0x3
	beq		@@vertical
	cmp		r0,0x4
	beq		@@vertical
@@horizontal:
	ldr		r0,=OAM_wpchor
	str		r0,[r4,0x4]
	b		@@return
@@diagonal:
	ldr		r0,=OAM_wpcdiag
	str		r0,[r4,0x4]
	b		@@return
@@vertical:
	ldr		r0,=OAM_wpcvert
	str		r0,[r4,0x4]
	b		@@return
@@hasice:
	ldrb	r0,[r4,0x10] ; direction
	cmp		r0,0x0
	beq		@@horizontalice
	cmp		r0,0x1
	beq		@@diagonalice
	cmp		r0,0x2
	beq		@@diagonalice
	cmp		r0,0x3
	beq		@@verticalice
	cmp		r0,0x4
	beq		@@verticalice
@@horizontalice:
	ldr		r0,=OAM_chargedicehor
	str		r0,[r4,0x4]
	b		@@return
@@diagonalice:
	ldr		r0,=OAM_chargedicediag
	str		r0,[r4,0x4]
	b		@@return
@@verticalice:
	ldr		r0,=OAM_chargedicevert
	str		r0,[r4,0x4]
	b		@@return
@@return:
	bx		r14


setplasmagfx1:
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x06
	and		r2,r1
	cmp		r2,0x06
	beq		@@ice
	mov		r2,0x02
	and		r2,r1
	cmp		r2,0x02
	beq		@@iceplasma
	mov		r2,0x4
	and		r2,r1
	cmp		r2,0x04
	bne		@@plasma
@@wave:
	ldr		r1,=waveplasmagfx
	b		@@return
@@iceplasma:
	ldr		r1,=iceplasmagfx
	b		@@return
@@ice:
	ldr		r1,=0x8328500
	b		@@return
@@plasma:
	ldr		r1,=0x8329ed4
@@return:
	str		r1,[r0]
	ldr		r1,=0x804f6f8
	mov		r15,r1


setplasmagfx2:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x06
	and		r2,r1
	cmp		r2,0x06
	beq		@@ice
	mov		r2,0x02
	and		r2,r1
	cmp		r2,0x02
	beq		@@iceplasma
	mov		r2,0x4
	and		r2,r1
	cmp		r2,0x04
	bne		@@plasma
@@wave:
	ldr		r1,=waveplasmagfx+0x200
	b		@@return
@@iceplasma:
	ldr		r1,=iceplasmagfx+0x200
	b		@@return
@@ice:
	ldr		r1,=0x8328500+0x200
	b		@@return
@@plasma:
	ldr		r1,=0x8329ed4+0x200
@@return:
	str		r1,[r0]
	pop		r2
	ldr		r1,=0x804f706
	mov		r15,r1


setplasmagfx3:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x06
	and		r2,r1
	cmp		r2,0x06
	beq		@@ice
	mov		r2,0x02
	and		r2,r1
	cmp		r2,0x02
	beq		@@iceplasma
	mov		r2,0x4
	and		r2,r1
	cmp		r2,0x04
	bne		@@plasma
@@wave:
	ldr		r1,=waveplasmagfx+0x400
	b		@@return
@@iceplasma:
	ldr		r1,=iceplasmagfx+0x400
	b		@@return
@@ice:
	ldr		r1,=0x8328500+0x400
	b		@@return
@@plasma:
	ldr		r1,=0x8329ed4+0x400
@@return:
	str		r1,[r0]
	pop		r2
	ldr		r1,=0x804f712
	mov		r15,r1


setplasmagfx4:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x06
	and		r2,r1
	cmp		r2,0x06
	beq		@@ice
	mov		r2,0x02
	and		r2,r1
	cmp		r2,0x02
	beq		@@iceplasma
	mov		r2,0x4
	and		r2,r1
	cmp		r2,0x04
	bne		@@plasma
@@wave:
	ldr		r1,=waveplasmagfx+0x600
	b		@@return
@@iceplasma:
	ldr		r1,=iceplasmagfx+0x600
	b		@@return
@@ice:
	ldr		r1,=0x8328500+0x600
	b		@@return
@@plasma:
	ldr		r1,=0x8329ed4+0x600
@@return:
	str		r1,[r0]
	pop		r2
	ldr		r1,=0x804f71e
	mov		r15,r1












;////////////////////////////////////////////charge beam
Chargebeam:

	cmp		r4,0x6
	blt		@@notcharged
	mov		r5,0xe8
	b		chargedcharge
@@notcharged:
	mov		r5,0x5f ; set normal charge beam sfx
	ldr		r0,=30013d6h
	ldrb	r0,[r0]
	cmp		r0,1h
	beq		diagonalcharge
	cmp		r0,2h
	beq 	diagonalcharge
	cmp		r0,3h
	beq		vertical1charge
	cmp		r0,4h
	beq		vertical1charge
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0xc
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4
;new ptype
	mov		r0,0x15
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0xc
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4

	b		returntocodecharge

diagonalcharge:
	cmp		r0,2h
	bne		@@upwards
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	beq		diagonalleftcharge
	b		@@continue
@@upwards:
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	bne		diagonalleftcharge
@@continue:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0x8
	mov		r0,r4
	mov		r0,0x15
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0x8
	b		returntocodecharge

vertical1charge:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0xc
	mov		r0,r4
	mov		r0,0x15
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,10h
	b		returntocodecharge

diagonalleftcharge:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0x8
	mov		r0,r4
	mov		r0,0x15
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0x8
	mov		r0,r4
	b		returntocodecharge

returntocodecharge:
spazerreturncharge:
	ldr		r0,=0804F18Ch
	mov		r15,r0

.pool

chargedcharge:
@@notcharged:
	ldr		r0,=30013d6h
	ldrb	r0,[r0]
	cmp		r0,1h
	beq		diagonalchargec
	cmp		r0,2h
	beq 	diagonalchargec
	cmp		r0,3h
	beq		vertical1chargec
	cmp		r0,4h
	beq		vertical1chargec
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0xc
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4
;new ptype
	mov		r0,0x16
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0xc
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4

	b		returntocodechargec

diagonalchargec:
	cmp		r0,2h
	bne		@@upwards
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	beq		diagonalleftchargec
	b		@@continue
@@upwards:
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	bne		diagonalleftchargec
@@continue:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0x8
	mov		r0,r4
	mov		r0,0x16
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0x8
	b		returntocodechargec

vertical1chargec:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0xc
	mov		r0,r4
	mov		r0,0x16
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,10h
	b		returntocodechargec

diagonalleftchargec:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0x8
	mov		r0,r4
	mov		r0,0x16
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0x8
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0x8
	mov		r0,r4
	b		returntocodechargec

returntocodechargec:
spazerreturnchargec:
	ldr		r0,=0804F18Ch
	mov		r15,r0

.pool


shortbeamhijack:
	ldr		r0,=0x300153d
	ldrb	r1,[r0]
	mov		r0,0x1f
	and		r0,r1
	cmp		r0,0x10
	beq		@@charge
	b		@@return
@@charge:
	ldrb	r0,[r4,0xf]
	cmp		r0,0x6
	bne		@@notrail
	mov		r0,r4
	mov		r1,0x18
	mov		r2,0x3
	ldr		r3,=0x804fc38
	bl		WrapperR3
@@notrail:
	ldrb	r0,[r4,0x2]
	cmp		r0,0x20
	beq		@@toppart
	ldrb	r0,[r4,0x1]
	bl		findchargetwin
	;check if other part exists
	cmp		r0,0x0
	beq		halfbeam
	;check direction based on GP
	ldrb	r0,[r4,0x10]
	cmp		r0,0x1
	beq		@@diagonal1
	cmp		r0,0x2
	beq		@@diagonal1
	cmp		r0,0x3
	beq		@@vertical1
	cmp		r0,0x4
	beq		@@vertical1
	cmp		r0,0x0
	;bne		@@nothorizontal1
	ldrb	r1,[r4,0xF]
	cmp		r1,0x6
	beq		@@chargehor
	ldr		r1,=OAM_chargehorizpart1
	str		r1,[r4,0x4]
	b		@@return
@@chargehor:
	ldr		r1,=OAM_chargedchargehorizpart1
	str		r1,[r4,0x4]
	b		@@return
@@nothorizontal1:
	b		@@return
@@diagonal1:
	ldrb	r1,[r4]
	mov		r0,0x40
	and		r0,r1
	cmp		r0,0x0
	beq		@@diagleft
	ldrb	r1,[r4,0xF]
	cmp		r1,0x6
	beq		@@chargediag
	ldr		r1,=OAM_chargediagpart1
	str		r1,[r4,0x4]
	b		@@return
@@diagleft:
	ldrb	r1,[r4,0xF]
	cmp		r1,0x6
	beq		@@chargediagleft
	ldr		r1,=OAM_chargediagpart1left
	str		r1,[r4,0x4]
	b		@@return
@@chargediag:
	ldr		r1,=OAM_chargedchargediagpart1
	str		r1,[r4,0x4]
	b		@@return
@@chargediagleft:
	ldr		r1,=OAM_chargedchargediagpart1left
	str		r1,[r4,0x4]
	b		@@return

@@vertical1:
	ldrb	r1,[r4]
	mov		r0,0x40
	and		r0,r1
	cmp		r0,0x0
	beq		@@vertleft
	ldrb	r1,[r4,0xF]
	cmp		r1,0x6
	beq		@@chargevert
	ldr		r1,=OAM_chargevertpart1
	str		r1,[r4,0x4]
	b		@@return
@@vertleft:
	ldrb	r1,[r4,0xF]
	cmp		r1,0x6
	beq		@@chargevertleft
	ldr		r1,=OAM_chargevertpart1left
	str		r1,[r4,0x4]
	b		@@return
@@chargevert:
	ldr		r1,=OAM_chargedchargevertpart1
	str		r1,[r4,0x4]
	b		@@return
@@chargevertleft:
	ldr		r1,=OAM_chargedchargevertpart1left
	str		r1,[r4,0x4]
	b		@@return
@@toppart:
	ldrb	r0,[r4,0x1]
	bl		findchargetwin
	;check if other part exists
	cmp		r0,0x0
	beq		halfbeam




	ldr		r0,[r4,0x4]
	ldr		r1,=0x8327a90
	cmp		r0,r1
	;bne		@@nothorizontal2
	ldr		r1,=invisibleoam
	str		r1,[r4,0x4]
	b		@@return
@@nothorizontal2:
	b		@@return

@@return:
	pop		r4
	ldr		r0,=0x8050c50
	mov		r15,r0


Halfbeam:
	ldr		r1,=OAM_chargehorizpart2
	str		r1,[r4,0x4]
	pop		r4
	ldr		r0,=0x8050c50
	mov		r15,r0
.pool

shortbeampalettehijack:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0xe
	and		r2,r1
	cmp		r2,0xc
	beq		@@waveplasma
	mov		r2,0x1f
	and		r2,r1
	cmp		r2,0x10
	bne		@@nocharge
	mov		r0,0x0
	ldr		r1,=chargepalette
	b		@@return
@@nocharge:
	ldr		r1,=0x83270e8
	b		@@return
@@waveplasma:
	mov		r0,0x0
	ldr		r1,=waveplasmapalette
	b		@@return
@@return:
	pop		r2
	add		r0,r0,r1
	str		r0,[r2]
	ldr		r0,=0x804f8dc
	mov		r15,r0


setchargegfx1:
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x1f
	and		r2,r1
	cmp		r2,0x10
	bne		@@nocharge
	ldr		r1,=chargegfx
	b		@@return
@@nocharge:
	ldr		r1,=0x83271a8
@@return:
	str		r1,[r0]
	ldr		r1,=0x804f8a2
	mov		r15,r1

setchargegfx2:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x1f
	and		r2,r1
	cmp		r2,0x10
	bne		@@nocharge
	ldr		r1,=chargegfx+0x200
	b		@@return
@@nocharge:
	ldr		r1,=0x83273a8
@@return:
	str		r1,[r0]
	pop		r2
	ldr		r1,=0x804f8b0
	mov		r15,r1

setchargegfx3:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x1f
	and		r2,r1
	cmp		r2,0x10
	bne		@@nocharge
	ldr		r1,=chargegfx+0x400
	b		@@return
@@nocharge:
	ldr		r1,=0x83275a8
@@return:
	str		r1,[r0]
	pop		r2
	ldr		r1,=0x804f8bc
	mov		r15,r1

setchargegfx4:
	push	r2
	ldr		r1,=0x300153D
	ldrb	r1,[r1]
	mov		r2,0x1f
	and		r2,r1
	cmp		r2,0x10
	bne		@@nocharge
	ldr		r1,=chargegfx+0x600
	b		@@return
@@nocharge:
	ldr		r1,=0x83277a8
@@return:
	str		r1,[r0]
	pop		r2
	ldr		r1,=0x804f8c8
	mov		r15,r1

.pool



WrapperR3:
	mov		r15,r3

widenspazer:
	ldrb	r0,[r4,0x13]
	add		r0,0x1
	strb	r0,[r4,0x13]

;widening factor
	cmp		r0,0x5
	bls     @@young
	mov		r0,0x00
@@young:
;make widening factor more extreme for plasma
	mov		r3,0x0
	ldr		r1,=0x300153d
	ldrb	r1,[r1]
	mov		r2,0x8
	and		r1,r2
	cmp		r1,0x0
	beq		@@noplasma1
	mov		r3,0x0
@@noplasma1:
;check direction
	ldrb	r1,[r4,0x10]
	cmp		r1,0x0
	beq		@@forward
	cmp		r1,0x3
	beq		@@vertical
	cmp		r1,0x4
	beq		@@vertical
	cmp		r1,0x1
	beq		@@diagup
	cmp		r1,0x2
	beq		@@diagdown
	b		@@forward

@@diagdown:
	cmp		r0,0x4
	bls     @@young1
	mov		r0,0x00
@@young1:
	lsl		r0,r0,0x2
	add		r0,r0,r3
	ldrb	r1,[r4]
	mov		r2,0x40
	and		r1,r2
	cmp		r1,0x0
	beq		@@diagdownleft
	b		@@diagdownright

@@diagdownleft:
;check top or bottom
	ldrb	r1,[r4,0x2]
	cmp		r1,0x20
	beq		@@downlefttop
	cmp		r1,0x40
	beq		@@downleftbottom
	b		@@return
@@downlefttop:
	ldrh	r1,[r4,0xa]
	sub		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	sub		r1,r0
	strh	r1,[r4,0x8]
	b		@@return
@@downleftbottom:
	ldrh	r1,[r4,0xa]
	add		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	add		r1,r0
	strh	r1,[r4,0x8]
	b		@@return

@@diagdownright:
;check top or bottom
	ldrb	r1,[r4,0x2]
	cmp		r1,0x20
	beq		@@downrighttop
	cmp		r1,0x40
	beq		@@downrightbottom
	b		@@return
@@downrighttop:
	ldrh	r1,[r4,0xa]
	add		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	sub		r1,r0
	strh	r1,[r4,0x8]
	b		@@return
@@downrightbottom:
	ldrh	r1,[r4,0xa]
	sub		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	add		r1,r0
	strh	r1,[r4,0x8]
	b		@@return





@@diagup:
	cmp		r0,0x4
	bls     @@young2
	mov		r0,0x00
@@young2:
	lsl		r0,r0,0x2
	add		r0,r0,r3
	ldrb	r1,[r4]
	mov		r2,0x40
	and		r1,r2
	cmp		r1,0x0
	beq		@@diagupleft
	b		@@diagupright

@@diagupleft:
;check top or bottom
	ldrb	r1,[r4,0x2]
	cmp		r1,0x20
	beq		@@uplefttop
	cmp		r1,0x40
	beq		@@upleftbottom
	b		@@return
@@uplefttop:
	ldrh	r1,[r4,0xa]
	add		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	sub		r1,r0
	strh	r1,[r4,0x8]
	b		@@return
@@upleftbottom:
	ldrh	r1,[r4,0xa]
	sub		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	add		r1,r0
	strh	r1,[r4,0x8]
	b		@@return

@@diagupright:
;check top or bottom
	ldrb	r1,[r4,0x2]
	cmp		r1,0x20
	beq		@@uprighttop
	cmp		r1,0x40
	beq		@@uprightbottom
	b		@@return
@@uprighttop:
	ldrh	r1,[r4,0xa]
	sub		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	sub		r1,r0
	strh	r1,[r4,0x8]
	b		@@return
@@uprightbottom:
	ldrh	r1,[r4,0xa]
	add		r1,r0
	strh	r1,[r4,0xa]
	ldrh	r1,[r4,0x8]
	add		r1,r0
	strh	r1,[r4,0x8]
	b		@@return




@@vertical:
	lsl		r0,r0,0x2
	add		r0,r0,r3;plasma scalar
;check left or right
	ldrb	r1,[r4,0x2]
	cmp		r1,0x20
	beq		@@left
	cmp		r1,0x40
	beq		@@right
	b		@@return
@@left:
	ldrh	r1,[r4,0xa]
	add		r1,r0
	strh	r1,[r4,0xa]
	b		@@return
@@right:
	ldrh	r1,[r4,0xa]
	sub		r1,r0
	strh	r1,[r4,0xa]
	b		@@return

@@forward:
	lsl		r0,r0,0x2
	add		r0,r0,r3;plasma scalar
;check top or bottom
	ldrb	r1,[r4,0x2]
	cmp		r1,0x20
	beq		@@bottom
	cmp		r1,0x40
	beq		@@top
	b		@@return
@@bottom:
	ldrh	r1,[r4,0x8]
	add		r1,r0
	strh	r1,[r4,0x8]
	b		@@return
@@top:
	ldrh	r1,[r4,0x8]
	sub		r1,r0
	strh	r1,[r4,0x8]
	b		@@return



@@return:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x8
	and		r1,r0
	cmp		r1,0x0
	beq		@@notplasma
	bl		seticeplasmagfx
	pop		r4-r6
	b		@@fullreturn
@@notplasma:
	mov		r1,0x4
	and		r1,r0
	cmp		r1,0x0
	beq		@@notwave
	pop		r4,r5
	b		@@fullreturn
@@notwave:
	pop		r4
@@fullreturn:
	pop		r0
	bx		r0

.pool







;///////////////////////////////////////////////////////////spazer





zero:
	ldr		r0,=0804F2a2h
	mov		r15,r0
spazer:
	pop	r0
	lsl	r0,r0,18h
	cmp	r0,0h
	bne	@@notzero
	b	zero
@@notzero:
	cmp		r4,0xb
	bcs		@@notbeam
	cmp		r4,0x6
	bcc		@@notchargedbeam
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x17
	ldr		r3,=@@spawnlinkflare
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlinkflare:

@@notchargedbeam:
@@notbeam:
	ldr		r0,=300153Dh
	ldrb	r0,[r0]
	mov		r1,1h
	and		r1,r0
	cmp		r1,0h
	bne		hasspazer

	ldr		r0,=300153Dh
	ldrb	r0,[r0]
	mov		r1,1fh
	and		r1,r0
	cmp		r1,10h
	bne		@@nocharge
	b		Chargebeam
@@nocharge:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode
hasspazer:	
	cmp		r4,0x7
	bcc		@@notcharged
	b		chargedspazer
@@notcharged:
	ldr		r0,=30013d6h
	ldrb	r0,[r0]
	cmp		r0,1h
	beq		diagonal
	cmp		r0,2h
	beq 	diagonal
	cmp		r0,3h
	beq		vertical1
	cmp		r0,4h
	beq		vertical1
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
;	sub		r1,30h
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4
;new ptype
	mov		r0,0x11
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
;	add		r1,30h
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4
;new ptype
	mov		r0,0x12
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode

diagonal:
	cmp		r0,2h
	bne		@@upwards
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	beq		diagonalleft
	b		@@continue
@@upwards:
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	bne		diagonalleft
@@continue:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	;sub		r1,22h
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	;sub		r2,22h
	mov		r0,r4
	mov		r0,0x11
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	;add		r1,22h
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	;add		r2,22h
	mov		r0,r4
	mov		r0,0x12
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode
vertical1:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	;sub		r2,30h
	mov		r0,r4
	mov		r0,0x11
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	;add		r2,30h
	mov		r0,r4
	mov		r0,0x12
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode
diagonalleft:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	;add		r1,22h
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	;sub		r2,22h
	mov		r0,r4
	mov		r0,0x11
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	;sub		r1,22h
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	;add		r2,22h
	mov		r0,r4
	mov		r0,0x12
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode
returntocode:
	mov		r0,r4
	cmp		r0,0x9
	bne		spazerreturn
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	lsl		r0,0x1f
	lsr		r0,0x1f
	cmp		r0,0x0
	bne		spazerreturn
	bl		doublewave
spazerreturn:
	ldr		r0,=0804F18Ch
	mov		r15,r0

.pool
;//////////////////////Charged Spazer
chargedspazer:
	ldr		r0,=30013d6h
	ldrb	r0,[r0]
	cmp		r0,1h
	beq		cdiagonal
	cmp		r0,2h
	beq 	cdiagonal
	cmp		r0,3h
	beq		cvertical1
	cmp		r0,4h
	beq		cvertical1
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
;new ptype
	mov		r0,0x13
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
;new ptype
	mov		r0,0x14
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode

cdiagonal:
	cmp		r0,2h
	bne		@@upwards
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	beq		cdiagonalleft
	b		@@continue
@@upwards:
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	bne		cdiagonalleft
@@continue:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x13
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x14
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode
cvertical1:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x13
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x14
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode
cdiagonalleft:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x13
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x14
	ldr		r3,=@@spawnlink
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		returntocode









;///////////////////////////
doublewave:
	ldr		r0,=30013d6h
	ldrb	r0,[r0]
	cmp		r0,1h
	beq		diagonal2
	cmp		r0,2h
	beq 	diagonal2
	cmp		r0,3h
	beq		vertical2
	cmp		r0,4h
	beq		vertical2
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0x10
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x10
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0x10
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,r4
	b		returntocode3

diagonal2:
	cmp		r0,2h
	bne		@@upwards
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	beq		diagonalleft2
	b		@@continue
@@upwards:
	ldr		r0,=030013E2h
	ldrb	r0,[r0]
	mov		r1,20h
	and		r1,r0
	cmp		r1,0h
	bne		diagonalleft2
@@continue:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0xb
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0xb
	mov		r0,0x10
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0xb
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0xb
	b		returntocode3
vertical2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0x10
	mov		r0,0x10
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0x10
	b		returntocode3
diagonalleft2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	add		r1,0xb
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	sub		r2,0xb
	mov		r0,0x10
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	sub		r1,0xb
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	add		r2,0xb
	b		returntocode3
returntocode3:
	ldr		r0,=spazerreturn
	mov		r15,r0
.pool



;///////////////////////////////////////////////////////////////////////




zero1:
	ldr		r0,=0804F2a2h
	mov		r15,r0
spawn2charges:
	pop	r0
	lsl	r0,r0,18h
	cmp	r0,0h
	bne	@@notzero
	b	zero
@@notzero:
	ldr		r0,=300153Dh
	ldrb	r0,[r0]
	mov		r1,1h
	and		r1,r0
	cmp		r4,9h
	beq		@@chargedwave
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		@@returntocode

@@chargedwave:	

	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	mov		r0,0x10
	ldr		r3,=@@spawnlink2
	add		r3,1h
	mov		r14,r3
	ldr		r3,=0804EDE4h
	mov		r15,r3
@@spawnlink2:
	ldr		r0,=03000BECh
	ldrh	r1,[r0]
	ldr		r0,=3000BEEh
	ldrh	r2,[r0]
	b		@@returntocode

@@returntocode:
	ldr		r0,=0804F18Ch
	mov		r15,r0



.pool



spawnhijack:
	mov		r1,r4
	cmp		r1,0x17
	bne		@@notflare
	b		@@flare
@@notflare:
	cmp		r1,0x11
	beq		@@topspazer
	cmp		r1,0x12
	beq		@@bottomspazer

	cmp		r1,0x13
	beq		@@topspazerc
	cmp		r1,0x14
	beq		@@bottomspazerc
	
	cmp		r1,0x15
	bne		@@nottopcharge
	b		@@topcharge
@@nottopcharge:
	cmp		r1,0x16
	bne		@@nottopchargeC
	b		@@topchargeC
@@nottopchargec:
	cmp		r1,0x0
	bne		@@notcharge
	b		@@bottomcharge
@@notcharge:
	cmp		r1,0x6
	bne		@@notchargec
	b		@@bottomchargec
@@notchargec:
	cmp		r1,0x10
	beq		@@notend
	b		@@end
@@notend:
	mov		r1,0x9
	mov		r4,r1
	mov		r0,0x6
	lsl		r0,r0,0x8
	orr		r2,r0
	b		@@end
	;strb	r0,[r3,0x1]
@@flare:
	mov		r1,0x6
	mov		r4,r1
	mov		r0,0x8
	lsl		r0,r0,0x14 ;orientation has 4000: top
	mov		r1,0x10
	orr		r0,r1
	orr		r2,r0
	b		@@end
@@topspazer:
	ldr		r1,=0x300153d
	ldrb	r1,[r1]
	mov		r0,0x8
	and		r0,r1
	cmp		r0,0x0
	bne		@@plasma1
	mov		r0,0x4
	and		r0,r1
	cmp		r0,0x0
	bne		@@wave1
	mov		r0,0x2
	and		r0,r1
	cmp		r0,0x0
	bne		@@ice1
	b		@@wide1
@@plasma1:
	mov		r1,0x4
	b		@@continue1
@@wave1:
	mov		r1,0x3
	b		@@continue1
@@ice1:
	mov		r1,0x2
	b		@@continue1
@@wide1:
	mov		r1,0x1
@@continue1:
	mov		r4,r1
	mov		r0,0x4
	lsl		r0,r0,0x14 ;orientation has 4000: top
	mov		r1,0x10
	orr		r0,r1
	mov		r1,0x1
	lsl		r1,r1,0x8
	orr		r0,r1
	orr		r2,r0
	b		@@end
@@bottomspazer:
	ldr		r1,=0x300153d
	ldrb	r1,[r1]
	mov		r0,0x8
	and		r0,r1
	cmp		r0,0x0
	bne		@@plasma2
	mov		r0,0x4
	and		r0,r1
	cmp		r0,0x0
	bne		@@wave2
	mov		r0,0x2
	and		r0,r1
	cmp		r0,0x0
	bne		@@ice2
	b		@@wide2
@@plasma2:
	mov		r1,0x4
	b		@@continue2
@@wave2:
	mov		r1,0x3
	b		@@continue2
@@ice2:
	mov		r1,0x2
	b		@@continue2
@@wide2:
	mov		r1,0x1
@@continue2:
	mov		r4,r1
	mov		r0,0x2
	lsl		r0,r0,0x14 ;orientation has 2000: bottom
	mov		r1,0x10
	orr		r0,r1
	mov		r1,0x7
	lsl		r1,r1,0x8
	orr		r0,r1
	orr		r2,r0
	b		@@end
@@topspazerc:
	ldr		r1,=0x300153d
	ldrb	r1,[r1]
	mov		r0,0x8
	and		r0,r1
	cmp		r0,0x0
	bne		@@plasma1c
	mov		r0,0x4
	and		r0,r1
	cmp		r0,0x0
	bne		@@wave1c
	mov		r0,0x2
	and		r0,r1
	cmp		r0,0x0
	bne		@@ice1c
	b		@@wide1c
@@plasma1c:
	mov		r1,0xa
	b		@@continue1c
@@wave1c:
	mov		r1,0x9
	b		@@continue1c
@@ice1c:
	mov		r1,0x8
	b		@@continue1c
@@wide1c:
	mov		r1,0x7
@@continue1c:
	mov		r4,r1
	mov		r0,0x4
	lsl		r0,r0,0x14 ;orientation has 4000: top
	mov		r1,0x10
	orr		r0,r1
	mov		r1,0x1
	lsl		r1,r1,0x8
	orr		r0,r1
	orr		r2,r0
	b		@@end
@@bottomspazerc:
	ldr		r1,=0x300153d
	ldrb	r1,[r1]
	mov		r0,0x8
	and		r0,r1
	cmp		r0,0x0
	bne		@@plasma2c
	mov		r0,0x4
	and		r0,r1
	cmp		r0,0x0
	bne		@@wave2c
	mov		r0,0x2
	and		r0,r1
	cmp		r0,0x0
	bne		@@ice2c
	b		@@wide2c
@@plasma2c:
	mov		r1,0xa
	b		@@continue2c
@@wave2c:
	mov		r1,0x9
	b		@@continue2c
@@ice2c:
	mov		r1,0x8
	b		@@continue2c
@@wide2c:
	mov		r1,0x7
@@continue2c:
	mov		r4,r1
	mov		r0,0x2
	lsl		r0,r0,0x14 ;orientation has 2000: bottom
	mov		r1,0x10
	orr		r0,r1
	mov		r1,0x7
	lsl		r1,r1,0x8
	orr		r0,r1
	orr		r2,r0
	b		@@end
@@topcharge:
	mov		r1,0x0
	mov		r4,r1
	mov		r0,0x2
	lsl		r0,r0,0x14 ;orientation has 2000: bottom
	mov		r1,0x10
	orr		r0,r1
	orr		r2,r0
	ldr		r1,=chargebeamID
	ldrb	r0,[r1]
	cmp		r0,0x50
	bcc		@@dontreset
	mov		r0,0x0
@@dontreset:
	add		r0,r0,0x1
	strb	r0,[r1]
	lsl		r0,r0,0x8
	orr		r2,r0
	b		@@end

@@topchargeC:
	mov		r1,0x6
	mov		r4,r1
	mov		r0,0x2
	lsl		r0,r0,0x14 ;orientation has 2000: bottom
	mov		r1,0x10
	orr		r0,r1
	orr		r2,r0
	ldr		r1,=chargebeamID
	ldrb	r0,[r1]
	cmp		r0,0x50
	bcc		@@dontresetc
	mov		r0,0x0
@@dontresetc:
	add		r0,r0,0x1
	strb	r0,[r1]
	lsl		r0,r0,0x8
	orr		r2,r0
	b		@@end
@@bottomcharge:
	mov		r1,0x0
	mov		r4,r1
	mov		r0,0x10
	orr		r2,r0
	ldr		r1,=chargebeamID
	ldrb	r0,[r1]
	cmp		r0,0x50
	lsl		r0,r0,0x8
	orr		r2,r0
	b		@@end
@@bottomchargeC:
	mov		r1,0x6
	mov		r4,r1
	mov		r0,0x10
	orr		r2,r0
	ldr		r1,=chargebeamID
	ldrb	r0,[r1]
	cmp		r0,0x50
	lsl		r0,r0,0x8
	orr		r2,r0
	b		@@end


@@end:
	mov		r0,r12
	ldrh	r1,[r0,0xE]
	mov		r0,0x10
	and		r0,r1
	cmp		r0,0x0
	beq		@@returnequal

	ldr		r1,=0x0804EE32
	mov		r15,r1
@@returnequal:
	ldr		r1,=0x804EE36
	mov		r15,r1
.pool




horizontal:
	push	r14
	mov		r2,r4
	ldrb	r0,[r2,0x1]
	cmp		r0,0x2
	bls		@@stage1
	cmp		r0,0x4
	bls		@@stage2
	cmp		r0,0x6
	bls		@@stage3
	cmp		r0,0x8
	bls		@@stage4
	cmp		r0,0xa
	bls		@@stage5
	cmp		r0,0xc
	bls		@@stage6
	mov		r0,0x0
	strb	r0,[r2,0x1]
	b		@@return
@@stage1:
	ldrh	r0,[r2,0x8]
	mov		r1,0x7
	sub		r0,r0,r1
	strh	r0,[r2,0x8]
	b		@@return
@@stage2:
	b		@@return
@@stage3:
	ldrh	r0,[r2,0x8]
	mov		r1,0x7
	add		r0,r0,r1
	strh	r0,[r2,0x8]
	b		@@return
@@stage4:
	ldrh	r0,[r2,0x8]
	mov		r1,0x7
	add		r0,r0,r1
	strh	r0,[r2,0x8]
	b		@@return
@@stage5:
	b		@@return
@@stage6:
	ldrh	r0,[r2,0x8]
	mov		r1,0x7
	sub		r0,r0,r1
	strh	r0,[r2,0x8]
	b		@@return

@@return:
	pop		r14
	bx		r14
.pool

vertical:
	push	r14
	mov		r2,r4
	ldrb	r0,[r2,0x1]
	cmp		r0,0x2
	bls		@@stage1
	cmp		r0,0x4
	bls		@@stage2
	cmp		r0,0x6
	bls		@@stage3
	cmp		r0,0x8
	bls		@@stage4
	cmp		r0,0xa
	bls		@@stage5
	cmp		r0,0xc
	bls		@@stage6
	mov		r0,0x0
	strb	r0,[r2,0x1]
	b		@@return
@@stage1:
	ldrh	r0,[r2,0xA]
	mov		r1,0x7
	sub		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage2:
	b		@@return
@@stage3:
	ldrh	r0,[r2,0xA]
	mov		r1,0x7
	add		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage4:
	ldrh	r0,[r2,0xA]
	mov		r1,0x7
	add		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage5:
	b		@@return
@@stage6:
	ldrh	r0,[r2,0xA]
	mov		r1,0x7
	sub		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return

@@return:
	pop		r14
	bx		r14
.pool

positiveslope:
	push	r14
	mov		r2,r4
	ldrb	r0,[r2,0x1]
	cmp		r0,0x2
	bls		@@stage1
	cmp		r0,0x4
	bls		@@stage2
	cmp		r0,0x6
	bls		@@stage3
	cmp		r0,0x8
	bls		@@stage4
	cmp		r0,0xa
	bls		@@stage5
	cmp		r0,0xc
	bls		@@stage6
	mov		r0,0x0
	strb	r0,[r2,0x1]
	b		@@return
@@stage1:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage2:
	b		@@return
@@stage3:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage4:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage5:
	b		@@return
@@stage6:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return

@@return:
	pop		r14
	bx		r14
.pool

negativeslope:
	push	r14
	mov		r2,r4
	ldrb	r0,[r2,0x1]
	cmp		r0,0x2
	bls		@@stage1
	cmp		r0,0x4
	bls		@@stage2
	cmp		r0,0x6
	bls		@@stage3
	cmp		r0,0x8
	bls		@@stage4
	cmp		r0,0xa
	bls		@@stage5
	cmp		r0,0xc
	bls		@@stage6
	mov		r0,0x0
	strb	r0,[r2,0x1]
	b		@@return
@@stage1:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage2:
	b		@@return
@@stage3:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage4:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return
@@stage5:
	b		@@return
@@stage6:
	ldrh	r0,[r2,0x8]
	mov		r1,0x5
	sub		r0,r0,r1
	strh	r0,[r2,0x8]
	ldrh	r0,[r2,0xA]
	mov		r1,0x5
	add		r0,r0,r1
	strh	r0,[r2,0xA]
	b		@@return

@@return:
	pop		r14
	bx		r14
.pool

flare:
	ldrb	r0,[r4,0x2]
	cmp		r0,0x80
	beq		@@flare
;	ldr     r0,=3001530
;	ldrb    r1,[r0,0Dh]
;	ldr		r0,=0x080518A8
;	mov		r15,r0
	ldr		r0,=0x3000079
	mov		r1,0x7
	strb	r1,[r0]
	ldr		r0,=0x8051450
	mov		r15,r0



@@flare:
	ldrb	r0,[r4,0x13]
	add		r0,0x1
	strb	r0,[r4,0x13]
	ldrb	r1,[r4,0x10]
	cmp		r1,0x0
	beq		@@sethitboxhor
	cmp		r1,0x3
	bcc		@@sethitboxdiag
	b		@@sethitboxvert


@@sethitboxvert:
	ldr		r1,=0xffe0
	strh	r1,[r4,0x14]
	mov		r1,0x50
	strh	r1,[r4,0x16]
	ldrb	r1,[r4]
	mov		r2,0x40
	and		r2,r1
	cmp		r2,0x0
	beq		@@leftvert
	ldr		r1,=0xFFc0
	strh	r1,[r4,0x18]
	mov		r1,0x40
	strh	r1,[r4,0x1a]
	b		@@setOAMvert
@@leftvert:
	ldr		r1,=0xFFc0
	strh	r1,[r4,0x18]
	mov		r1,0x40
	strh	r1,[r4,0x1a]
@@setOAMvert:
	ldr		r1,=vertflareoam
	str		r1,[r4,0x4]
	cmp		r0,0x4
	bcc		@@vert1
	cmp		r0,0x5
	bcc		@@vert2
	cmp		r0,0x6
	bcc		@@vert3
	cmp		r0,0x7
	bcc		@@vert4
	cmp		r0,0x8
	bcc		@@vert5
	b		@@die



@@sethitboxdiag:
	ldr		r1,=0xFFc0
	strh	r1,[r4,0x18]
	mov		r1,0x40
	strh	r1,[r4,0x1a]
	ldrb	r1,[r4]
	mov		r2,0x20
	and		r2,r1
	cmp		r2,0x0
	beq		@@updiag
	ldr		r1,=0xffb0
	strh	r1,[r4,0x14]
	mov		r1,0x18
	strh	r1,[r4,0x16]
	b		@@setOAMdiag
@@updiag:
	ldr		r1,=0xffe8
	strh	r1,[r4,0x14]
	mov		r1,0x50
	strh	r1,[r4,0x16]



@@setOAMdiag:
	ldr		r1,=diagflareoam
	str		r1,[r4,0x4]
	cmp		r0,0x4
	bcc		@@diag1
	cmp		r0,0x5
	bcc		@@diag2
	cmp		r0,0x6
	bcc		@@diag3
	cmp		r0,0x7
	bcc		@@diag4
	cmp		r0,0x8
	bcc		@@diag5
	b		@@die

@@sethitboxhor:
	ldr		r1,=0xfff8
	strh	r1,[r4,0x14]
	mov		r1,0x50
	strh	r1,[r4,0x16]
	ldrb	r1,[r4]
	mov		r2,0x40
	and		r2,r1
	cmp		r2,0x0
	beq		@@left
	ldr		r1,=0xFFA0
	strh	r1,[r4,0x18]
	mov		r1,0x40
	strh	r1,[r4,0x1a]
	b		@@setOAMhor
@@left:
	ldr		r1,=0xFFc0
	strh	r1,[r4,0x18]
	mov		r1,0x60
	strh	r1,[r4,0x1a]
@@setOAMhor:
	ldr		r1,=horflareoam
	str		r1,[r4,0x4]
	cmp		r0,0x4
	bcc		@@hor1
	cmp		r0,0x5
	bcc		@@hor2
	cmp		r0,0x6
	bcc		@@hor3
	cmp		r0,0x7
	bcc		@@hor4
	cmp		r0,0x8
	bcc		@@hor5
	b		@@die

@@vert1:
	ldr		r3,=vert1
	b		@@setgfx
@@vert2:
	ldr		r3,=vert2
	b		@@setgfx
@@vert3:
	ldr		r3,=vert3
	b		@@setgfx
@@vert4:
	ldr		r3,=vert4
	b		@@setgfx
@@vert5:
	ldr		r3,=vert5
	b		@@setgfx

@@diag1:
	ldr		r3,=diag1
	b		@@setgfx
@@diag2:
	ldr		r3,=diag2
	b		@@setgfx
@@diag3:
	ldr		r3,=diag3
	b		@@setgfx
@@diag4:
	ldr		r3,=diag4
	b		@@setgfx
@@diag5:
	ldr		r3,=diag5
	b		@@setgfx

@@hor1:
	ldr		r3,=hor1
	b		@@setgfx
@@hor2:
	ldr		r3,=hor2
	b		@@setgfx
@@hor3:
	ldr		r3,=hor3
	b		@@setgfx
@@hor4:
	ldr		r3,=hor4
	b		@@setgfx
@@hor5:
	ldr		r3,=hor5
	b		@@setgfx

@@setgfx:
	ldr		r0,=0x40000d4
	str		r3,[r0]
	ldr		r1,=0x6010900
	str		r1,[r0,0x4]
	ldr		r2,=0x80000080
	str		r2,[r0,0x8]
	ldr		r1,[r0,0x8]
	ldr		r1,=0x6010d00
	str		r1,[r0,0x4]
	ldr		r1,=0x100
	add		r1,r1,r3
	str		r1,[r0]
	str		r2,[r0,0x8]
	ldr		r1,[r0,0x8]

	b		@@return

@@die:
	mov		r0,0x0
	str		r0,[r4]
	b		@@return
@@return:
;	pop		r4-r6
	pop		r4
	pop		r14
	bx		r14

.pool



wavebeamhijack:
	push	r5
	push	r4
	ldrb	r0,[r4,0xF]
	cmp		r0,0x9
	beq		@@chargedwave
	cmp		r0,0x3
	beq		@@normalwave
	cmp		r0,0x4
	beq 	@@plasma
	cmp		r0,0xa
	beq		@@chargedplasma
	b		@@returnwithoutr1
@@plasma:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x4
	and		r0,r1
	ldr		r1,=0x80511a0
	cmp		r0,0x0
	beq		@@returnwithoutr1
	b		@@continue
@@chargedplasma:
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	mov		r1,0x4
	and		r0,r1
	ldr		r1,=0x80518a8
	cmp		r0,0x0
	beq		@@returnwithoutr1
	b		@@continue

@@normalwave:
	ldr		r1,=0x8051084
	b		@@continue
@@chargedwave:
	ldr		r1,=0x8051780
	b		@@continue
@@continue:
	push	r1
	mov		r1,r4
	ldr		r0,=0x300153d
	ldrb	r0,[r0]
	lsl		r0,r0,0x1f
	lsr		r0,r0,0x1f
	cmp		r0,0x1
	bne		@@wiggle
	ldrb	r0,[r4,0x2]
	cmp		r0,0x0
	beq		@@return
@@wiggle:
	ldrb	r1,[r1]
	mov		r0,0x1
	and		r0,r1
	mov		r1,r4
	cmp		r0,0x0
	beq		@@reset
	ldrb	r0,[r1,0x1]
	add		r0,r0,0x1
	cmp		r0,0xc
	bcc		@@dontreset
@@reset:
	mov		r0,0
@@dontreset:
	strb	r0,[r1,0x1]
	ldrb	r0,[r1,0x10]
	cmp		r0,0x0
	beq		@@horizontal
	cmp		r0,0x2
	bhi		@@vertical
	cmp		r0,0x1
	beq		@@diagup
	cmp		r0,0x2
	beq		@@diagdown
@@diagup:
	ldrb	r0,[r1]
	mov		r1,0x40
	and		r0,r1
	cmp		r0,0
	bne		@@positiveslope
	b		@@negativeslope
@@diagdown:
	ldrb	r0,[r1]
	mov		r1,0x40
	and		r0,r1
	cmp		r0,0
	beq		@@positiveslope
	b		@@negativeslope

@@horizontal:
	bl		horizontal
	b		@@return
@@vertical:
	bl		vertical
	b		@@return
@@positiveslope:
	bl		positiveslope
	b		@@return
@@negativeslope:
	bl		negativeslope
	b		@@return


@@return:
	pop		r1
@@returnwithoutr1:
	pop		r4
	pop		r5
	ldrb	r0,[r4,0xf]
	cmp		r0,0x4
	beq		@@plasmareturn
	cmp		r0,0xa
	beq		@@plasmareturn

	ldr		r0,=Equipment
	ldrb	r0,[r0,0xD]
	mov		r15,r1
@@plasmareturn:
	mov		r0,r1
	ldr		r1,=Equipment
	ldrb	r1,[r1,0xD]
	mov		r15,r0

.pool

.include "gfx\wideoam.asm"
.include "gfx\chargewideoam.asm"
.include "gfx\chargeoam.asm"
.include "gfx\plasmaoam.asm"
.include "gfx\iceoam.asm"
.include "gfx\waveplasmaoam.asm"
chargepalette:
.import "gfx\charge.palette"
.align 0x10
chargegfx:
.import "gfx\charge.gfx"
iceplasmagfx:
.import "gfx\iceplasma.gfx"
waveplasmagfx:
.import "gfx\waveplasma.gfx"
.align 0x10
waveplasmapalette:
.import "gfx\waveplasma.palette"

.align 0x10
.align
horflareoamframe:
.align
	.halfword	0002
	.halfword	0x40f4,0x81f0,0x2048
	.halfword	0x4004,0x81f0,0x204c

.align
horflareoam:
.word horflareoamframe
.word 0x000000ff
.word 0x0,0x0

.align
diagflareoamframe:
.align
	.halfword	0002
	.halfword	0x40f4,0x81f0,0x2048
	.halfword	0x4004,0x81f0,0x204c

.align
diagflareoam:
.word diagflareoamframe
.word 0x000000ff
.word 0x0,0x0

.align
vertflareoamframe:
.align
	.halfword	0002
	.halfword	0x40f4,0x81f0,0x2048
	.halfword	0x4004,0x81f0,0x204c

.align
vertflareoam:
.word vertflareoamframe
.word 0x000000ff
.word 0x0,0x0

.align 0x10
hor1:
.import "flare\hor\hor1.gfx"
hor2:
.import "flare\hor\hor2.gfx"
hor3:
.import "flare\hor\hor3.gfx"
hor4:
.import "flare\hor\hor4.gfx"
hor5:
.import "flare\hor\hor5.gfx"
diag1:
.import "flare\diag\diag1.gfx"
diag2:
.import "flare\diag\diag2.gfx"
diag3:
.import "flare\diag\diag3.gfx"
diag4:
.import "flare\diag\diag4.gfx"
diag5:
.import "flare\diag\diag5.gfx"
vert1:
.import "flare\vert\vert1.gfx"
vert2:
.import "flare\vert\vert2.gfx"
vert3:
.import "flare\vert\vert3.gfx"
vert4:
.import "flare\vert\vert4.gfx"
vert5:
.import "flare\vert\vert5.gfx"

.align 0x10
.include "sfx\voicetable080a6af0.asm"
.align 0x10
.include "sfx\voicetable080a7654.asm"
.include "sfx\songdata.asm"
.align 0x10
.include "sfx\headerfile.asm"